unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  GraphUtil, GraphType, StdCtrls, ExtCtrls, ugradbtn;

type
  TArrayPoints = Array of TPoint;
  TGradLine = record
      X, YStart, YEnd : Integer;
  end;

  TGradLines = Array of TGradLine;

  TGradFunction = function(AHeight, AWidth, AX: Integer): Integer;
  TGradFigureFunction = procedure(const R: TRect; var P: TArrayPoints; var L : TGradLines);



  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    ColorButton1: TColorButton;
    ColorButton2: TColorButton;
    ColorButton3: TColorButton;
    ColorButton4: TColorButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    PaintBox1: TPaintBox;
    Panel1: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    TheFunction : TGradFunction;
    TheFigure : TGradFigureFunction;
  end; 

  function NormGrad(AHeight, AWidth, AX : Integer) : Integer;
  function SinGrad(AHeight, AWidth, AX : Integer) : Integer;
  function CosGrad(AHeight, AWidth, AX : Integer) : Integer;
  function TestGrad(AHeight, AWidth, AX : Integer) : Integer;
  function TryGrad(AHeight, AWidth, AX : Integer) : Integer;
  function Max(AHeight, AWidth : Integer; TheFunction :TGradFunction) : Integer;
  function Min(AHeight, AWidth : Integer; TheFunction :TGradFunction) : Integer;
  procedure PaintGradientLine(StartY, EndY, MaxY, MinY, X: Integer; ColorOne, ColorTwo : TColor;
     TargetCanvas: TCanvas);
  procedure PaintGradient(TheLines : TGradLines; TheFunction: TGradFunction; ColorTopStart, ColorTopEnd,
     ColorBottomStart, ColorBottomEnd : TColor; TargetCanvas : TCanvas);
  function Max(TheLines : TGradLines) : Integer;
  function MaxX(TheLines: TGradLines): Integer;
  function Min(TheLines : TGradLines) : Integer;
  procedure ArrowFigure(const R: TRect; var P: TArrayPoints; var L : TGradLines);
  procedure BoxFigure(const R: TRect; var P: TArrayPoints; var L : TGradLines);

var
  Form1: TForm1; 

implementation

uses
    Math, GraphMath, extgraphics, LCLProc;

{ TForm1 }

function IncAr(var Ar : TGradLines) : Integer;
begin
   Result := Length(Ar);
   SetLength(Ar, Length(Ar)+1);
end;

procedure ArrowFigure(const R: TRect; var P: TArrayPoints; var L : TGradLines);
var dy:Integer;cntPoint:TPoint;
    m1,m2, b1, b2 : Extended;
    cur : TGradLine;
    i,last : Integer;

    function f1(x:Integer) : Extended;
    begin
        Result := m1*x + b1;
    end;

    function f2(x:Integer) : Extended;
    begin
        Result := m2*x + b2;
    end;
begin
  cntPoint:=CenterPoint(R);
  SetLength(P, 7);
  with R do
    begin
      dy:=(Bottom - Top) div 4;
      P[0].x:=Left;
      P[0].y:=Top+dy;

      P[1].x:=cntPoint.x;
      P[1].y:=P[0].y;

      P[2].x:=cntPoint.x;
      P[2].y:=Top;

      P[3].x:=Right;
      P[3].y:=cntPoint.y;

      P[4].x:=cntPoint.x;
      P[4].y:= Bottom;

      P[5].x:= cntPoint.x;
      P[5].y:=Bottom-dy;

      P[6].x:= Left;
      P[6].y:=P[5].y;
    end;

  m1 := (P[3].y-P[2].y)/(P[3].x-P[2].x);
  m2 := (P[3].y-P[4].y)/(P[3].x-P[4].x);

  b1 := P[3].y - P[3].x * m1;
  b2 := P[3].y - P[3].x * m2;

  for i := P[0].x to P[1].x do begin
      last := IncAr(L);
      with cur do
      begin
         X:= Trunc(i);
         YStart:=Trunc(P[0].y);
         YEnd:= Trunc(P[6].y);
      end;
      L[last] := cur;
  end;

  for i := P[2].x+1 to P[3].x-1 do begin
      last := IncAr(L);
      with cur do
      begin
         X:= Trunc(i);
         YStart:=Trunc(f1(i));
         YEnd:=Trunc(f2(i));
      end;
      L[last] := cur;
  end;
end;

procedure BoxFigure(const R: TRect; var P: TArrayPoints; var L: TGradLines);
var
   cur : TGradLine;
   i,last : Integer;
begin
   SetLength(P,4);

   with R do begin
   P[0].x := Right;
   P[0].y := Top;

   P[1].x := Left;
   P[1].y := Top;

   P[2].x := Left;
   P[2].y := Bottom;

   P[3].x := Right;
   P[3].y := Bottom;

   for i := Left to Right do
   begin
      last := IncAr(L);
      with cur do
      begin
         X:= i;
         YStart := TOp;
         YEnd := Bottom;
      end;
      L[last] := cur;
   end;

   end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
   AHeight, AWidth, i, ma, mi : Integer;
   P : TArrayPoints;
   L : TGradLines;
begin
   if TheFunction = nil then Exit;
   if TheFigure = nil then Exit;

   PaintBox1.Canvas.Brush.Color:=Color;
   PaintBox1.Canvas.FillRect(0,0,PaintBox1.Width, PaintBox1.Height);

   TheFigure(Rect(0,0,PaintBox1.Width-1, PaintBox1.Height-1),P, L);

   PaintGradient(L, TheFunction, ColorButton1.ButtonColor, ColorButton2.ButtonColor,
       ColorButton3.ButtonColor, ColorButton4.ButtonColor, PaintBox1.Canvas);

   PaintBox1.Canvas.Brush.Style:=bsClear;
   PaintBox1.Canvas.Polygon(P);
   PaintBox1.Canvas.Brush.Style:=bsSolid;

   SetLength(P,0);
   SetLength(L,0);
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  case ComboBox1.ItemIndex of
       0 : TheFunction := @NormGrad;
       1 : TheFunction := @SinGrad;
       2 : TheFunction := @CosGrad;
       3 : TheFunction := @TestGrad;
  end;
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
  case ComboBox2.ItemIndex of
       0 : TheFigure := @ArrowFigure;
       1 : TheFigure := @BoxFigure;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ComboBox1.Items.Add('Norm');
  ComboBox1.Items.Add('Sin');
  ComboBox1.Items.Add('Cos');
  ComboBox1.Items.Add('Test');

  ComboBox2.Items.Add('Arrow');
  ComboBox2.Items.Add('Box');
end;

function NormGrad(AHeight, AWidth, AX: Integer): Integer;
begin
   Result := AHeight div 2;
end;

function SinGrad(AHeight, AWidth, AX: Integer): Integer;
begin
   Result := trunc(sin(pi * AX / AWidth)*AHeight/16) + AHeight div 2;
end;

function CosGrad(AHeight, AWidth, AX: Integer): Integer;
begin
   Result := trunc(cos(pi * AX / AWidth)*AHeight/16) + AHeight div 2;
end;

function TestGrad(AHeight, AWidth, AX: Integer): Integer;
begin
  Result := AX;
end;

function TryGrad(AHeight, AWidth, AX: Integer): Integer;
begin

end;

function Max(AHeight, AWidth: Integer; TheFunction: TGradFunction): Integer;
var
   i,l,r : Integer;
begin
   Result := 2;
   if TheFunction = nil then Exit;
   r := 0;
   for i := 0 to AWidth do begin
      l := TheFunction(AHeight,AWidth,i);

      if l > r then begin Result := i; R := l end;
   end;
end;

function Min(AHeight, AWidth: Integer; TheFunction: TGradFunction): Integer;
var
   i,l,r : Integer;
begin
   if TheFunction = nil then Exit;
   r := AHeight;
   for i := 0 to AWidth do begin
      l := TheFunction(AHeight,AWidth,i);

      if l < r then begin Result := i; R := l end;
   end;
end;

procedure PaintGradientLine(StartY, EndY, MaxY, MinY, X: Integer; ColorOne,
  ColorTwo: TColor; TargetCanvas: TCanvas);
var
   i : Integer;
   r : Extended;
   d : Integer;
begin
   //if MaxY > MinY then d := MaxY else d := MinY;

   DebugLn('SY=%d EY=%d iY=%d aY=%d x=%d',[StartY, EndY, MaxY, MinY, X]);

   for i := StartY to EndY do begin
       r := (i-MinY)/MaxY;

       TargetCanvas.Pixels[X, i] := ColorBetween(ColorOne, ColorTwo, r);
   end;
end;

procedure PaintGradient(TheLines: TGradLines;  TheFunction: TGradFunction; ColorTopStart, ColorTopEnd,
  ColorBottomStart, ColorBottomEnd: TColor; TargetCanvas: TCanvas);
var
   AHeight, AWidth, i, x, maF, miF, maArea, miArea, ma, sY, eY : Integer;
   P : TArrayPoints;
   L : TGradLines;
begin
   if TheFunction = nil then Exit;

   maArea := Max(TheLines);
   miArea := Min(TheLines);

   ma := MaxX(TheLines);

   AHeight:= maArea-miArea;
   AWidth:= ma;

   maF := Max(AHeight, AWidth, TheFunction);
   miF := Min(AHeight, AWidth, TheFunction);

   for i := Low(TheLines) to High(TheLines) do begin
        x := TheLines[i].X;
        //TargetCanvas.Pixels[x, TheFunction(AHeight,AWidth,x)] := clBlack;

        eY := TheFunction(AHeight, AWidth, x);
        sY := eY;

        if eY > TheLines[i].YEnd then eY := TheLines[i].YEnd;
        if sY < TheLines[i].YStart then sY := TheLines[i].YStart;

        PaintGradientLine(TheLines[i].YStart, eY,
             TheFunction(AHeight,AWidth,MaF),
             miArea,
             x, ColorTopStart, ColorTopEnd, TargetCanvas);
        PaintGradientLine(sY, TheLines[i].YEnd,
             maArea,
             TheFunction(AHeight,AWidth,MiF),
             x, ColorBottomStart, ColorBottomEnd, TargetCanvas);
   end;
end;

function Max(TheLines: TGradLines): Integer;
var
   i,l,r : Integer;
begin
   Result := 0;
   for i := Low(TheLines) to High(TheLines) do begin
      l := TheLines[i].YEnd;

      if l > Result then begin Result := l; end;
   end;
end;

function MaxX(TheLines: TGradLines): Integer;
var
   i,l,r : Integer;
begin
   Result := 0;
   for i := Low(TheLines) to High(TheLines) do begin
      l := TheLines[i].X;

      if l > Result then begin Result := l; end;
   end;
end;

function Min(TheLines: TGradLines): Integer;
var
   i,l,r : Integer;
begin
   Result := Max(TheLines);
   for i := Low(TheLines) to High(TheLines) do begin
      l := TheLines[i].YStart;

      if l < Result then begin Result := l; end;
   end;
end;

initialization
  {$I unit1.lrs}

end.

